from logging import getLogger
from typing import Any, Dict
logger = getLogger(__name__)
import requests
import httpx

class RemoteEngine():
    """基础远程服务类, 提供远程调用的基础框架。"""
    def __init__(self, api_key: str, base_url: str):
        self._api_key = api_key
        self._base_url = base_url
        self.url = self._base_url
        self.header = {
            'Content-Type': 'application/json',
            'Authorization': 'Bearer ' + self._api_key
        }

    async def post_prompt(self, messages : Dict) -> httpx.Response:
        try:
            async with httpx.AsyncClient() as client:
                response = await client.post(self.url, headers=self.header, json=messages)
                return response.raise_for_status()
        except Exception as e:
            logger.exception("post_prompt")
            raise e