from typing import Any, Generator
from src import Engine
import wave
import io
import pyaudio

from src import StreamEngine

class SoundsPlayEngine(StreamEngine):
    def __init__(self, **kwargs) -> None:
        # super().__init__(kwargs.get("is_stream", _is_stream))
        StreamEngine.__init__(self,
                              use_stream_api=kwargs.get('use_stream_api', False),
                              return_as_stream=kwargs.get('return_as_stream', False))

    def execute_nonstream(self, data) -> Any:
        if data is None:
            return None
        wf = wave.open(io.BytesIO(data), 'rb')
        _audio  = pyaudio.PyAudio()
        _stream = _audio.open(
            format=_audio.get_format_from_width(wf.getsampwidth()),
            channels=wf.getnchannels(),
            rate=wf.getframerate(),
            output=True)
        data = wf.readframes(1024)  # 假定块大小为1024
        while data:
            _stream.write(data)
            data = wf.readframes(1024)

        _stream.stop_stream()
        _stream.close()

        _audio.terminate()
        wf.close()
